// Available modules include (this is not a complete list):
var Scene = require('Scene');


//Esta instrucción se descontinuó, ahora usamos patches
//This instruction has been deprecated, now we use patches
//var Instruction = require('Instruction');
//Instruction.show('TAP_TO_ADVANCE')

var Textures = require('Textures');
var Materials = require('Materials');
var FaceTracking = require('FaceTracking');
var Animation = require('Animation');
var Reactive = require('Reactive');
var Touch = require('TouchGestures');
var Audio = require('Audio');

const lentes = Textures.get('lentes');
const lentesOP = Materials.get('lentes');
const DW2D = Scene.root.find('DW2D');
const DWT = Materials.get('DealWithText');
const DWW = Materials.get('White');
const Trapper = Scene.root.find('Audio');

lentesOP.opacity = 0
DWT.opacity=0
DWW.opacity=0

//var faceSignalX = FaceTracking.face(0).cameraTransform.x;
//var faceSignalY = FaceTracking.face(0).cameraTransform.y;
//var faceSignalZ = FaceTracking.face(0).cameraTransform.z;

var rotaY = FaceTracking.face(0).cameraTransform.rotationY;
var rotaX = FaceTracking.face(0).cameraTransform.rotationX;

var driver = Animation.timeDriver({durationMilliseconds: 2450});
var reseter= Animation.timeDriver({durationMilliseconds: 10000});
var sampler = Animation.samplers.linear(22.4, 2.4);

DW2D.transform.rotationY=Reactive.mul(rotaY, -1);
DW2D.transform.rotationX=Reactive.mul(rotaX, -1);

lentes.currentFrame = Reactive.floor(Reactive.mul(Reactive.add(rotaY,1),2.5));

Touch.onTap().subscribe(function(e) {
		driver.reset();
		driver.start();
	
		Audio.stopAll(Trapper);
		Audio.play(Trapper);
		reseter.reset();
		reseter.start();
	
		lentesOP.opacity = 1
		DWT.opacity=0
		DWW.opacity=0
		DW2D.transform.y = Animation.animate(driver, sampler);		
});

		driver.onCompleted().subscribe(function(f) {
			DWT.opacity=1
			DWW.opacity=1
			});

reseter.onCompleted().subscribe(function(g) {
			//driver.reset();
			DWT.opacity=0
			DWW.opacity=0
			Audio.stopAll(Trapper);
			lentesOP.opacity = 0
});